"use strict";var util=require("./util"),enums_1=require("./enums"),assert_1=require("./assert"),CP_CLASSES={},ConstUTF8=function(){function a(a){this.value=this.bytes2str(a)}return a.prototype.bytes2str=function(a){for(var b,c,d,e,f=0,g="";f<a.length;)d=255&a[f++],d<=127?e=d:d<=223?(b=a[f++],e=((31&d)<<6)+(63&b)):(b=a[f++],c=a[f++],e=((15&d)<<12)+((63&b)<<6)+(63&c)),g+=String.fromCharCode(e);return g},a.prototype.getType=function(){return enums_1.ConstantPoolItemType.UTF8},a.prototype.getConstant=function(a){return this.value},a.prototype.isResolved=function(){return!0},a.fromBytes=function(a,b){var c=a.getUint16();return new this(a.read(c))},a.size=1,a.infoByteSize=0,a}();exports.ConstUTF8=ConstUTF8,CP_CLASSES[enums_1.ConstantPoolItemType.UTF8]=ConstUTF8;var ConstInt32=function(){function a(a){this.value=a}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.INTEGER},a.prototype.getConstant=function(a){return this.value},a.prototype.isResolved=function(){return!0},a.fromBytes=function(a,b){return new this(a.getInt32())},a.size=1,a.infoByteSize=4,a}();exports.ConstInt32=ConstInt32,CP_CLASSES[enums_1.ConstantPoolItemType.INTEGER]=ConstInt32;var ConstFloat=function(){function a(a){this.value=a}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.FLOAT},a.prototype.getConstant=function(a){return this.value},a.prototype.isResolved=function(){return!0},a.fromBytes=function(a,b){return new this(a.getFloat())},a.size=1,a.infoByteSize=4,a}();exports.ConstFloat=ConstFloat,CP_CLASSES[enums_1.ConstantPoolItemType.FLOAT]=ConstFloat;var ConstLong=function(){function a(a){this.value=a}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.LONG},a.prototype.getConstant=function(a){return this.value},a.prototype.isResolved=function(){return!0},a.fromBytes=function(a,b){return new this(a.getInt64())},a.size=2,a.infoByteSize=8,a}();exports.ConstLong=ConstLong,CP_CLASSES[enums_1.ConstantPoolItemType.LONG]=ConstLong;var ConstDouble=function(){function a(a){this.value=a}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.DOUBLE},a.prototype.getConstant=function(a){return this.value},a.prototype.isResolved=function(){return!0},a.fromBytes=function(a,b){return new this(a.getDouble())},a.size=2,a.infoByteSize=8,a}();exports.ConstDouble=ConstDouble,CP_CLASSES[enums_1.ConstantPoolItemType.DOUBLE]=ConstDouble;var ClassReference=function(){function a(a){this.cls=null,this.clsConstructor=null,this.arrayClass=null,this.arrayClassConstructor=null,this.name=a}return a.prototype.tryResolve=function(a){return null===this.cls&&(this.cls=a.getResolvedClass(this.name)),null!==this.cls},a.prototype.resolve=function(a,b,c,d,e){var f=this;if(void 0===e&&(e=!0),null!==a){var g=a.currentMethod();if(null!==g&&this.name===g.cls.getInternalName())return this.setResolved(a,a.currentMethod().cls),d(!0)}b.resolveClass(a,this.name,function(b){f.setResolved(a,b),d(null!==b)},e)},a.prototype.setResolved=function(a,b){this.cls=b,null!==b&&(this.clsConstructor=b.getConstructor(a))},a.prototype.getType=function(){return enums_1.ConstantPoolItemType.CLASS},a.prototype.getConstant=function(a){return this.cls.getClassObject(a)},a.prototype.isResolved=function(){return null!==this.cls},a.fromBytes=function(a,b){var c=a.getUint16(),d=b.get(c);return assert_1["default"](d.getType()===enums_1.ConstantPoolItemType.UTF8,"ConstantPool ClassReference type != UTF8"),new this(util.typestr2descriptor(d.value))},a.size=1,a.infoByteSize=2,a}();exports.ClassReference=ClassReference,CP_CLASSES[enums_1.ConstantPoolItemType.CLASS]=ClassReference;var NameAndTypeInfo=function(){function a(a,b){this.name=a,this.descriptor=b}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.NAME_AND_TYPE},a.prototype.isResolved=function(){return!0},a.fromBytes=function(a,b){var c=a.getUint16(),d=a.getUint16(),e=b.get(c),f=b.get(d);return assert_1["default"](e.getType()===enums_1.ConstantPoolItemType.UTF8&&f.getType()===enums_1.ConstantPoolItemType.UTF8,"ConstantPool NameAndTypeInfo types != UTF8"),new this(e.value,f.value)},a.size=1,a.infoByteSize=4,a}();exports.NameAndTypeInfo=NameAndTypeInfo,CP_CLASSES[enums_1.ConstantPoolItemType.NAME_AND_TYPE]=NameAndTypeInfo;var ConstString=function(){function a(a){this.value=null,this.stringValue=a}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.STRING},a.prototype.resolve=function(a,b,c,d){this.value=a.getJVM().internString(this.stringValue),setImmediate(function(){return d(!0)})},a.prototype.getConstant=function(a){return this.value},a.prototype.isResolved=function(){return null!==this.value},a.fromBytes=function(a,b){var c=a.getUint16(),d=b.get(c);return assert_1["default"](d.getType()===enums_1.ConstantPoolItemType.UTF8,"ConstantPool ConstString type != UTF8"),new this(d.value)},a.size=1,a.infoByteSize=2,a}();exports.ConstString=ConstString,CP_CLASSES[enums_1.ConstantPoolItemType.STRING]=ConstString;var MethodType=function(){function a(a){this.methodType=null,this.descriptor=a}return a.prototype.resolve=function(a,b,c,d){var e=this;util.createMethodType(a,b,this.descriptor,function(b,c){b?(a.throwException(b),d(!1)):(e.methodType=c,d(!0))})},a.prototype.getConstant=function(a){return this.methodType},a.prototype.getType=function(){return enums_1.ConstantPoolItemType.METHOD_TYPE},a.prototype.isResolved=function(){return null!==this.methodType},a.fromBytes=function(a,b){var c=a.getUint16(),d=b.get(c);return assert_1["default"](d.getType()===enums_1.ConstantPoolItemType.UTF8,"ConstantPool MethodType type != UTF8"),new this(d.value)},a.size=1,a.infoByteSize=2,a}();exports.MethodType=MethodType,CP_CLASSES[enums_1.ConstantPoolItemType.METHOD_TYPE]=MethodType;var MethodReference=function(){function a(a,b){this.method=null,this.fullSignature=null,this.paramWordSize=-1,this.memberName=null,this.appendix=null,this.jsConstructor=null,this.classInfo=a,this.nameAndTypeInfo=b,this.signature=this.nameAndTypeInfo.name+this.nameAndTypeInfo.descriptor}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.METHODREF},a.prototype.hasAccess=function(a,b,c){var d=this.method,e=b.method.cls;return d.accessFlags.isStatic()!==c?(a.throwNewException("Ljava/lang/IncompatibleClassChangeError;","Method "+d.name+" from class "+d.cls.getExternalName()+" is "+(c?"not ":"")+"static."),b.returnToThreadLoop=!0,!1):!!util.checkAccess(e,d.cls,d.accessFlags)||(a.throwNewException("Ljava/lang/IllegalAccessError;",e.getExternalName()+" cannot access "+d.cls.getExternalName()+"."+d.name),b.returnToThreadLoop=!0,!1)},a.prototype.resolveMemberName=function(a,b,c,d,e){var f=this,g=b.getBsCl().getInitializedClass(b,"Ljava/lang/invoke/MethodHandleNatives;").getConstructor(b),h=new(b.getBsCl().getInitializedClass(b,"[Ljava/lang/Object;").getConstructor(b))(b,1);util.createMethodType(b,c,this.nameAndTypeInfo.descriptor,function(a,c){a?(b.throwException(a),e(!1)):g["java/lang/invoke/MethodHandleNatives/linkMethod(Ljava/lang/Class;ILjava/lang/Class;Ljava/lang/String;Ljava/lang/Object;[Ljava/lang/Object;)Ljava/lang/invoke/MemberName;"](b,[d.getClassObject(b),enums_1.MethodHandleReferenceKind.INVOKEVIRTUAL,f.classInfo.cls.getClassObject(b),b.getJVM().internString(f.nameAndTypeInfo.name),c,h],function(a,c){null!==a?(b.throwException(a),e(!1)):(f.appendix=h.array[0],f.memberName=c,e(!0))})})},a.prototype.resolve=function(a,b,c,d,e){var f=this;if(void 0===e&&(e=!0),this.classInfo.isResolved()){var g=this.classInfo.cls,h=g.methodLookup(this.signature);if(null===h&&util.is_reference_type(g.getInternalName())&&(h=g.signaturePolymorphicAwareMethodLookup(this.signature),null!==h&&("invoke"===h.name||"invokeExact"===h.name)))return this.resolveMemberName(h,a,b,c,function(b){b===!0?f.setResolved(a,h):a.throwNewException("Ljava/lang/NoSuchMethodError;","Method "+f.signature+" does not exist in class "+f.classInfo.cls.getExternalName()+"."),d(b)});null!==h?(this.setResolved(a,h),d(!0)):(a.throwNewException("Ljava/lang/NoSuchMethodError;","Method "+this.signature+" does not exist in class "+this.classInfo.cls.getExternalName()+"."),d(!1))}else this.classInfo.resolve(a,b,c,function(g){g?f.resolve(a,b,c,d,e):d(!1)},e)},a.prototype.setResolved=function(a,b){this.method=b,this.paramWordSize=util.getMethodDescriptorWordSize(this.nameAndTypeInfo.descriptor),this.fullSignature=this.method.fullSignature,this.jsConstructor=this.method.cls.getConstructor(a)},a.prototype.isResolved=function(){return null!==this.method},a.prototype.getParamWordSize=function(){return this.paramWordSize===-1&&(this.paramWordSize=util.getMethodDescriptorWordSize(this.nameAndTypeInfo.descriptor)),this.paramWordSize},a.fromBytes=function(a,b){var c=a.getUint16(),d=a.getUint16(),e=b.get(c),f=b.get(d);return assert_1["default"](e.getType()===enums_1.ConstantPoolItemType.CLASS&&f.getType()===enums_1.ConstantPoolItemType.NAME_AND_TYPE,"ConstantPool MethodReference types mismatch"),new this(e,f)},a.size=1,a.infoByteSize=4,a}();exports.MethodReference=MethodReference,CP_CLASSES[enums_1.ConstantPoolItemType.METHODREF]=MethodReference;var InterfaceMethodReference=function(){function a(a,b){this.fullSignature=null,this.method=null,this.paramWordSize=-1,this.jsConstructor=null,this.classInfo=a,this.nameAndTypeInfo=b,this.signature=this.nameAndTypeInfo.name+this.nameAndTypeInfo.descriptor}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.INTERFACE_METHODREF},a.prototype.hasAccess=function(a,b,c){var d=this.method,e=b.method.cls;return d.accessFlags.isStatic()!==c?(a.throwNewException("Ljava/lang/IncompatibleClassChangeError;","Method "+d.name+" from class "+d.cls.getExternalName()+" is "+(c?"not ":"")+"static."),b.returnToThreadLoop=!0,!1):!!util.checkAccess(e,d.cls,d.accessFlags)||(a.throwNewException("Ljava/lang/IllegalAccessError;",e.getExternalName()+" cannot access "+d.cls.getExternalName()+"."+d.name),b.returnToThreadLoop=!0,!1)},a.prototype.resolve=function(a,b,c,d,e){var f=this;if(void 0===e&&(e=!0),this.classInfo.isResolved()){var g=this.classInfo.cls,h=g.methodLookup(this.signature);this.paramWordSize=util.getMethodDescriptorWordSize(this.nameAndTypeInfo.descriptor),null!==h?(this.setResolved(a,h),d(!0)):(a.throwNewException("Ljava/lang/NoSuchMethodError;","Method "+this.signature+" does not exist in class "+this.classInfo.cls.getExternalName()+"."),d(!1))}else this.classInfo.resolve(a,b,c,function(g){g?f.resolve(a,b,c,d,e):d(!1)},e)},a.prototype.setResolved=function(a,b){this.method=b,this.paramWordSize=util.getMethodDescriptorWordSize(this.nameAndTypeInfo.descriptor),this.fullSignature=this.method.fullSignature,this.jsConstructor=this.method.cls.getConstructor(a)},a.prototype.getParamWordSize=function(){return this.paramWordSize===-1&&(this.paramWordSize=util.getMethodDescriptorWordSize(this.nameAndTypeInfo.descriptor)),this.paramWordSize},a.prototype.isResolved=function(){return null!==this.method},a.fromBytes=function(a,b){var c=a.getUint16(),d=a.getUint16(),e=b.get(c),f=b.get(d);return assert_1["default"](e.getType()===enums_1.ConstantPoolItemType.CLASS&&f.getType()===enums_1.ConstantPoolItemType.NAME_AND_TYPE,"ConstantPool InterfaceMethodReference types mismatch"),new this(e,f)},a.size=1,a.infoByteSize=4,a}();exports.InterfaceMethodReference=InterfaceMethodReference,CP_CLASSES[enums_1.ConstantPoolItemType.INTERFACE_METHODREF]=InterfaceMethodReference;var FieldReference=function(){function a(a,b){this.field=null,this.fullFieldName=null,this.fieldOwnerConstructor=null,this.classInfo=a,this.nameAndTypeInfo=b}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.FIELDREF},a.prototype.hasAccess=function(a,b,c){var d=this.field,e=b.method.cls;return d.accessFlags.isStatic()!==c?(a.throwNewException("Ljava/lang/IncompatibleClassChangeError;","Field "+name+" from class "+d.cls.getExternalName()+" is "+(c?"not ":"")+"static."),b.returnToThreadLoop=!0,!1):!!util.checkAccess(e,d.cls,d.accessFlags)||(a.throwNewException("Ljava/lang/IllegalAccessError;",e.getExternalName()+" cannot access "+d.cls.getExternalName()+"."+name),b.returnToThreadLoop=!0,!1)},a.prototype.resolve=function(a,b,c,d,e){var f=this;if(void 0===e&&(e=!0),this.classInfo.isResolved()){var g=this.classInfo.cls,h=g.fieldLookup(this.nameAndTypeInfo.name);null!==h?(this.fullFieldName=util.descriptor2typestr(h.cls.getInternalName())+"/"+h.name,this.field=h,d(!0)):(a.throwNewException("Ljava/lang/NoSuchFieldError;","Field "+this.nameAndTypeInfo.name+" does not exist in class "+this.classInfo.cls.getExternalName()+"."),d(!1))}else this.classInfo.resolve(a,b,c,function(g){g?f.resolve(a,b,c,d,e):d(!1)},e)},a.prototype.isResolved=function(){return null!==this.field},a.fromBytes=function(a,b){var c=a.getUint16(),d=a.getUint16(),e=b.get(c),f=b.get(d);return assert_1["default"](e.getType()===enums_1.ConstantPoolItemType.CLASS&&f.getType()===enums_1.ConstantPoolItemType.NAME_AND_TYPE,"ConstantPool FieldReference types mismatch"),new this(e,f)},a.size=1,a.infoByteSize=4,a}();exports.FieldReference=FieldReference,CP_CLASSES[enums_1.ConstantPoolItemType.FIELDREF]=FieldReference;var InvokeDynamic=function(){function a(a,b){this.callSiteObjects={},this.methodType=null,this.bootstrapMethodAttrIndex=a,this.nameAndTypeInfo=b,this.paramWordSize=util.getMethodDescriptorWordSize(this.nameAndTypeInfo.descriptor)}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.INVOKE_DYNAMIC},a.prototype.isResolved=function(){return null!==this.methodType},a.prototype.resolve=function(a,b,c,d){var e=this;util.createMethodType(a,b,this.nameAndTypeInfo.descriptor,function(b,c){b?(a.throwException(b),d(!1)):(e.methodType=c,d(!0))})},a.prototype.getCallSiteObject=function(a){var b=this.callSiteObjects[a];return b?b:null},a.prototype.constructCallSiteObject=function(a,b,c,d,e,f){function g(){var c,d,e=i[1],f=new(a.getBsCl().getInitializedClass(a,"[Ljava/lang/Object;").getConstructor(a))(a,e.length),g=f.array;for(c=0;c<e.length;c++)switch(d=e[c],d.getType()){case enums_1.ConstantPoolItemType.CLASS:g[c]=d.cls.getClassObject(a);break;case enums_1.ConstantPoolItemType.METHOD_HANDLE:g[c]=d.methodHandle;break;case enums_1.ConstantPoolItemType.METHOD_TYPE:g[c]=d.methodType;break;case enums_1.ConstantPoolItemType.STRING:g[c]=d.value;break;case enums_1.ConstantPoolItemType.UTF8:g[c]=a.getJVM().internString(d.value);break;case enums_1.ConstantPoolItemType.INTEGER:g[c]=b.getInitializedClass(a,"I").createWrapperObject(a,d.value);break;case enums_1.ConstantPoolItemType.LONG:g[c]=b.getInitializedClass(a,"J").createWrapperObject(a,d.value);break;case enums_1.ConstantPoolItemType.FLOAT:g[c]=b.getInitializedClass(a,"F").createWrapperObject(a,d.value);break;case enums_1.ConstantPoolItemType.DOUBLE:g[c]=b.getInitializedClass(a,"D").createWrapperObject(a,d.value);break;default:assert_1["default"](!1,"Invalid CPItem for static args: "+enums_1.ConstantPoolItemType[d.getType()])}return assert_1["default"](function(){var a=!0;return e.forEach(function(b,c){void 0===g[c]?(console.log("Undefined item at arg "+c+": "+enums_1.ConstantPoolItemType[b.getType()]),a=!1):null===g[c]&&(console.log("Null item at arg "+c+": "+enums_1.ConstantPoolItemType[b.getType()]),a=!1)}),a}(),"Arguments cannot be undefined or null."),f}var h=this;void 0===f&&(f=!0);var i=c.getBootstrapMethod(this.bootstrapMethodAttrIndex),j=i[1].concat(i[0],this).filter(function(a){return!a.isResolved()});if(j.length>0)return util.asyncForEach(j,function(d,e){d.resolve(a,b,c,function(a){a?e():e("Failed.")},f)},function(g){g?e(!1):h.constructCallSiteObject(a,b,c,d,e,f)});var k=a.getJVM().internString(this.nameAndTypeInfo.name),l=new(b.getInitializedClass(a,"[Ljava/lang/Object;").getConstructor(a))(a,1),m=g(),n=b.getInitializedClass(a,"Ljava/lang/invoke/MethodHandleNatives;").getConstructor(a);n["java/lang/invoke/MethodHandleNatives/linkCallSite(Ljava/lang/Object;Ljava/lang/Object;Ljava/lang/Object;Ljava/lang/Object;Ljava/lang/Object;[Ljava/lang/Object;)Ljava/lang/invoke/MemberName;"](a,[c.getClassObject(a),i[0].methodHandle,k,this.methodType,m,l],function(b,c){b?(a.throwException(b),e(!1)):(h.setResolved(d,[c,l.array[0]]),e(!0))})},a.prototype.setResolved=function(a,b){void 0===this.callSiteObjects[a]&&(this.callSiteObjects[a]=b)},a.fromBytes=function(a,b){var c=a.getUint16(),d=a.getUint16(),e=b.get(d);return assert_1["default"](e.getType()===enums_1.ConstantPoolItemType.NAME_AND_TYPE,"ConstantPool InvokeDynamic types mismatch"),new this(c,e)},a.size=1,a.infoByteSize=4,a}();exports.InvokeDynamic=InvokeDynamic,CP_CLASSES[enums_1.ConstantPoolItemType.INVOKE_DYNAMIC]=InvokeDynamic;var MethodHandle=function(){function a(a,b){this.methodHandle=null,this.reference=a,this.referenceType=b}return a.prototype.getType=function(){return enums_1.ConstantPoolItemType.METHOD_HANDLE},a.prototype.isResolved=function(){return null!==this.methodHandle},a.prototype.getConstant=function(a){return this.methodHandle},a.prototype.resolve=function(a,b,c,d,e){var f=this;return this.reference.isResolved()?void this.constructMethodHandleType(a,b,function(e){if(null===e)d(!1);else{var g=b.getInitializedClass(a,"Ljava/lang/invoke/MethodHandleNatives;").getConstructor(a);g["linkMethodHandleConstant(Ljava/lang/Class;ILjava/lang/Class;Ljava/lang/String;Ljava/lang/Object;)Ljava/lang/invoke/MethodHandle;"](a,[c.getClassObject(a),f.referenceType,f.getDefiningClassObj(a),a.getJVM().internString(f.reference.nameAndTypeInfo.name),e],function(b,c){b?(a.throwException(b),d(!1)):(f.methodHandle=c,d(!0))})}}):this.reference.resolve(a,b,c,function(g){g?f.resolve(a,b,c,d,e):d(!1)},e)},a.prototype.getDefiningClassObj=function(a){return this.reference.getType()===enums_1.ConstantPoolItemType.FIELDREF?this.reference.field.cls.getClassObject(a):this.reference.method.cls.getClassObject(a)},a.prototype.constructMethodHandleType=function(a,b,c){if(this.reference.getType()===enums_1.ConstantPoolItemType.FIELDREF){var d=this.reference.nameAndTypeInfo.descriptor;b.resolveClass(a,d,function(b){c(null!==b?b.getClassObject(a):null)})}else util.createMethodType(a,b,this.reference.nameAndTypeInfo.descriptor,function(b,d){b?(a.throwException(b),c(null)):c(d)})},a.fromBytes=function(a,b){var c=a.getUint8(),d=a.getUint16(),e=b.get(d);return assert_1["default"](0<c&&c<10,"ConstantPool MethodHandle invalid referenceKind: "+c),assert_1["default"](function(){switch(c){case enums_1.MethodHandleReferenceKind.GETFIELD:case enums_1.MethodHandleReferenceKind.GETSTATIC:case enums_1.MethodHandleReferenceKind.PUTFIELD:case enums_1.MethodHandleReferenceKind.PUTSTATIC:return e.getType()===enums_1.ConstantPoolItemType.FIELDREF;case enums_1.MethodHandleReferenceKind.INVOKEINTERFACE:return e.getType()===enums_1.ConstantPoolItemType.INTERFACE_METHODREF&&"<"!==e.nameAndTypeInfo.name[0];case enums_1.MethodHandleReferenceKind.INVOKEVIRTUAL:case enums_1.MethodHandleReferenceKind.INVOKESTATIC:case enums_1.MethodHandleReferenceKind.INVOKESPECIAL:return(e.getType()===enums_1.ConstantPoolItemType.METHODREF||e.getType()===enums_1.ConstantPoolItemType.INTERFACE_METHODREF)&&"<"!==e.nameAndTypeInfo.name[0];case enums_1.MethodHandleReferenceKind.NEWINVOKESPECIAL:return e.getType()===enums_1.ConstantPoolItemType.METHODREF&&"<init>"===e.nameAndTypeInfo.name}return!0}(),"Invalid constant pool reference for method handle reference type: "+enums_1.MethodHandleReferenceKind[c]),new this(e,c)},a.size=1,a.infoByteSize=3,a}();exports.MethodHandle=MethodHandle,CP_CLASSES[enums_1.ConstantPoolItemType.METHOD_HANDLE]=MethodHandle;var CONSTANT_POOL_TIER=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];!function(a){a.forEach(function(a,b){a.forEach(function(a){CONSTANT_POOL_TIER[a]=b})})}([[enums_1.ConstantPoolItemType.UTF8,enums_1.ConstantPoolItemType.INTEGER,enums_1.ConstantPoolItemType.FLOAT,enums_1.ConstantPoolItemType.LONG,enums_1.ConstantPoolItemType.DOUBLE],[enums_1.ConstantPoolItemType.CLASS,enums_1.ConstantPoolItemType.STRING,enums_1.ConstantPoolItemType.NAME_AND_TYPE,enums_1.ConstantPoolItemType.METHOD_TYPE],[enums_1.ConstantPoolItemType.FIELDREF,enums_1.ConstantPoolItemType.METHODREF,enums_1.ConstantPoolItemType.INTERFACE_METHODREF,enums_1.ConstantPoolItemType.INVOKE_DYNAMIC],[enums_1.ConstantPoolItemType.METHOD_HANDLE]]);var ConstantPool=function(){function a(){}return a.prototype.parse=function(a,b){var c=this;void 0===b&&(b=null);var d=a.getUint16(),e=[[],[],[]],f=0,g=1,h=0,i=0,j=0;for(this.constantPool=new Array(d);g<d;)i=a.pos(),h=a.getUint8(),assert_1["default"](null!==CP_CLASSES[h]&&void 0!==CP_CLASSES[h],"Unknown ConstantPool tag: "+h),j=CONSTANT_POOL_TIER[h],j>0?(e[j-1].push({offset:i,index:g}),a.skip(CP_CLASSES[h].infoByteSize)):this.constantPool[g]=CP_CLASSES[h].fromBytes(a,this),g+=CP_CLASSES[h].size;return f=a.pos(),e.forEach(function(d){d.forEach(function(d){if(a.seek(d.offset),h=a.getUint8(),c.constantPool[d.index]=CP_CLASSES[h].fromBytes(a,c),null!==b&&null!==b.array[d.index]&&void 0!==b.array[d.index]){var e=b.array[d.index];switch(e.getClass().getInternalName()){case"Ljava/lang/Integer;":assert_1["default"](h===enums_1.ConstantPoolItemType.INTEGER),c.constantPool[d.index].value=e["java/lang/Integer/value"];break;case"Ljava/lang/Long;":assert_1["default"](h===enums_1.ConstantPoolItemType.LONG),c.constantPool[d.index].value=e["java/lang/Long/value"];break;case"Ljava/lang/Float;":assert_1["default"](h===enums_1.ConstantPoolItemType.FLOAT),c.constantPool[d.index].value=e["java/lang/Float/value"];break;case"Ljava/lang/Double;":assert_1["default"](h===enums_1.ConstantPoolItemType.DOUBLE),c.constantPool[d.index].value=e["java/lang/Double/value"];break;case"Ljava/lang/String;":assert_1["default"](h===enums_1.ConstantPoolItemType.UTF8),c.constantPool[d.index].value=e.toString();break;case"Ljava/lang/Class;":assert_1["default"](h===enums_1.ConstantPoolItemType.CLASS),c.constantPool[d.index].name=e.$cls.getInternalName(),c.constantPool[d.index].cls=e.$cls;break;default:assert_1["default"](h===enums_1.ConstantPoolItemType.STRING),c.constantPool[d.index].stringValue="",c.constantPool[d.index].value=e}}})}),a.seek(f),a},a.prototype.get=function(a){return assert_1["default"](void 0!==this.constantPool[a],"Invalid ConstantPool reference."),this.constantPool[a]},a.prototype.each=function(a){this.constantPool.forEach(function(b,c){void 0!==b&&a(c,b)})},a}();exports.ConstantPool=ConstantPool;
//# sourceMappingURL=ConstantPool.js.map